#!/bin/sh
#
#
#
####################################################
# Author: Gary Keen
# Date: 9/15/08
# Discription:
#       Change a users htpasswd but include the PIN
#       that THEY will know and Email the token #.
#
####################################################
# Reference:
# The line below is to slow and ineffective
# od -A x -t x2 /dev/random ( or a file name )
#
# Now this line worked but hexdump does not exist in Solaris 
# but od does.
# hexdump -C -n 4 -s m -x /dev/random |head -1| awk '{print $2$3$4$5}'|cut -c2-5 
#
# This command generates randomness across Linux and Solaris
# od -A x -t x -N 4 /dev/random | awk '{print $3}' | head -1
#
# REdirection from a php cgi script. Won't work here.
# $location="http://www.google.com";
# print "Location: $location\n\n"; 
#
# The major environment variables that can be accessed by the CGI script when it executes are: 
# Environment variable  	 Contains
# QUERY_STRING 	Data sent to the CGI script, by its caller.
# 		This may be the output from a form, or other 
#		dynamically or statically generated data.
# REMOTE_ADDR 	The Internet address of the host machine making the request.
#
#
####################################################

#------------------ Variables ---------------------#


echo -e "Content-type: text/html\n\n"
echo "<html><head></head><body>"


UI=`echo $QUERY_STRING | awk -F"=" '{print $2}'`
## echo $UI


PASFILE=/etc/httpd/htauth/htpasswd_file
MASLIST=/etc/httpd/htauth/cellist
HTPASSWD=/usr/bin/htpasswd
DATE=`date +%m:%d:%y`
TIME=`date +%H:%M:%S`
YEAR=`date +%Y`
HOUR=`date +%H`
MIN=`date +%M`
SEC=`date +%S`


if [ -z "$UI" ]  
then
echo "Use the back button to return to the login page."
echo "Please enter user name"
exit 0
else
USER=$UI
## echo $USER
fi

#--------- Does the user have an account ---------#

cat $MASLIST |grep $USER >/dev/null 2<&1
FOUND=$?
if [ $FOUND != 0 ]
then
echo "You don't have a user account. Try again."
exit 0
else
USER=$USER
fi


PIN=`cat $MASLIST | grep $USER |awk -F":" '{print $2}'`
MAILADRS=`cat $MASLIST | grep $USER |awk -F":" '{print $3}'`
# USER=`cat $MASLIST |awk -F":" '{print $1}'`
USER=$USER

#------------------ Functions --------------------#

genrandom () {
# RANDUM=`hexdump -C -n 4 -s m -x /dev/random |head -1| awk '{print $2$3$4$5}'|cut -c2-5` 
## echo $RANDUM
RANDUM=`/usr/bin/od -A x -t x -N 4 /dev/random |head -1 |awk '{print $2}' |cut -c1-6`
}
#
mailout () {
echo "    $RANDUM    " | mail -s "Your security token" $MAILADRS
echo "You will be directed to your secured page and your token ID is being Emailed."
sleep 1
}
#
genpasswd () {
## /usr/bin/htpasswd -b /etc/httpd/htauth/htpasswd_file $USER $PIN$RANDUM
## echo "$HTPASSWD -b $PASFILE $USER $PIN$RANDUM"
$HTPASSWD -b $PASFILE $USER $PIN$RANDUM >/dev/null 2<&1 
}


#------------------- Go to work ------------------#


genrandom
genpasswd
mailout


#-------------------------------------------------#




sleep 1

echo "<p>Click <a href="/gosecure.html"> here to be redirected to a list of secured directories. </p>"
# echo "<p>Click <a href="/restricted"> here to be redirected to a list of secured directories. </p>"



echo "</body></html>"

## exit 0


#--------------------- EOF ---------------------#
